//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef ClientIPCTypes_h
#define ClientIPCTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/TimeStamp.h"
#include "mozilla/dom/ClientIPCUtils.h"
#include "mozilla/dom/DOMTypes.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"
#include "mozilla/dom/IPCServiceWorkerDescriptor.h"
#include "mozilla/ipc/ProtocolTypes.h"

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientSourceConstructorArgs|
//
namespace mozilla {
namespace dom {
class ClientSourceConstructorArgs final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT ClientSourceConstructorArgs();

    MOZ_IMPLICIT ClientSourceConstructorArgs(
            const nsID& _id,
            const ClientType& _type,
            const PrincipalInfo& _principalInfo,
            const TimeStamp& _creationTime)
    {
        Init();
        Assign(_id, _type, _principalInfo, _creationTime);
    }

    MOZ_IMPLICIT ClientSourceConstructorArgs(const ClientSourceConstructorArgs& _o)
    {
        Init();
        Assign((_o).id(), (_o).type(), (_o).principalInfo(), (_o).creationTime());
    }

    ~ClientSourceConstructorArgs();

    void
    operator=(const ClientSourceConstructorArgs& _o)
    {
        Assign((_o).id(), (_o).type(), (_o).principalInfo(), (_o).creationTime());
    }

    bool
    operator==(const ClientSourceConstructorArgs& _o) const;

    bool
    operator!=(const ClientSourceConstructorArgs& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    ClientType&
    type()
    {
        return type_;
    }
    const ClientType&
    type() const
    {
        return type_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    TimeStamp&
    creationTime()
    {
        return creationTime_;
    }
    const TimeStamp&
    creationTime() const
    {
        return creationTime_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _id,
            const ClientType& _type,
            const PrincipalInfo& _principalInfo,
            const TimeStamp& _creationTime);

    nsID id_;
    ClientType type_;
    PrincipalInfo principalInfo_;
    TimeStamp creationTime_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCClientInfo|
//
namespace mozilla {
namespace dom {
class IPCClientInfo final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT IPCClientInfo();

    MOZ_IMPLICIT IPCClientInfo(
            const nsID& _id,
            const ClientType& _type,
            const PrincipalInfo& _principalInfo,
            const TimeStamp& _creationTime,
            const nsCString& _url,
            const FrameType& _frameType)
    {
        Init();
        Assign(_id, _type, _principalInfo, _creationTime, _url, _frameType);
    }

    MOZ_IMPLICIT IPCClientInfo(const IPCClientInfo& _o)
    {
        Init();
        Assign((_o).id(), (_o).type(), (_o).principalInfo(), (_o).creationTime(), (_o).url(), (_o).frameType());
    }

    ~IPCClientInfo();

    void
    operator=(const IPCClientInfo& _o)
    {
        Assign((_o).id(), (_o).type(), (_o).principalInfo(), (_o).creationTime(), (_o).url(), (_o).frameType());
    }

    bool
    operator==(const IPCClientInfo& _o) const;

    bool
    operator!=(const IPCClientInfo& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    ClientType&
    type()
    {
        return type_;
    }
    const ClientType&
    type() const
    {
        return type_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    TimeStamp&
    creationTime()
    {
        return creationTime_;
    }
    const TimeStamp&
    creationTime() const
    {
        return creationTime_;
    }

    nsCString&
    url()
    {
        return url_;
    }
    const nsCString&
    url() const
    {
        return url_;
    }

    FrameType&
    frameType()
    {
        return frameType_;
    }
    const FrameType&
    frameType() const
    {
        return frameType_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _id,
            const ClientType& _type,
            const PrincipalInfo& _principalInfo,
            const TimeStamp& _creationTime,
            const nsCString& _url,
            const FrameType& _frameType);

    nsID id_;
    ClientType type_;
    PrincipalInfo principalInfo_;
    TimeStamp creationTime_;
    nsCString url_;
    FrameType frameType_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCClientWindowState|
//
namespace mozilla {
namespace dom {
class IPCClientWindowState final
{
private:
    typedef mozilla::TimeStamp TimeStamp;
    typedef nsContentUtils::StorageAccess StorageAccess;

public:
    MOZ_IMPLICIT IPCClientWindowState();

    MOZ_IMPLICIT IPCClientWindowState(
            const VisibilityState& _visibilityState,
            const TimeStamp& _lastFocusTime,
            const StorageAccess& _storageAccess,
            const bool& _focused)
    {
        Init();
        Assign(_visibilityState, _lastFocusTime, _storageAccess, _focused);
    }

    MOZ_IMPLICIT IPCClientWindowState(const IPCClientWindowState& _o)
    {
        Init();
        Assign((_o).visibilityState(), (_o).lastFocusTime(), (_o).storageAccess(), (_o).focused());
    }

    ~IPCClientWindowState();

    void
    operator=(const IPCClientWindowState& _o)
    {
        Assign((_o).visibilityState(), (_o).lastFocusTime(), (_o).storageAccess(), (_o).focused());
    }

    bool
    operator==(const IPCClientWindowState& _o) const;

    bool
    operator!=(const IPCClientWindowState& _o) const;

    VisibilityState&
    visibilityState()
    {
        return visibilityState_;
    }
    const VisibilityState&
    visibilityState() const
    {
        return visibilityState_;
    }

    TimeStamp&
    lastFocusTime()
    {
        return lastFocusTime_;
    }
    const TimeStamp&
    lastFocusTime() const
    {
        return lastFocusTime_;
    }

    StorageAccess&
    storageAccess()
    {
        return storageAccess_;
    }
    const StorageAccess&
    storageAccess() const
    {
        return storageAccess_;
    }

    bool&
    focused()
    {
        return focused_;
    }
    const bool&
    focused() const
    {
        return focused_;
    }

private:
    void
    Init();

    void
    Assign(
            const VisibilityState& _visibilityState,
            const TimeStamp& _lastFocusTime,
            const StorageAccess& _storageAccess,
            const bool& _focused);

    VisibilityState visibilityState_;
    TimeStamp lastFocusTime_;
    StorageAccess storageAccess_;
    bool focused_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCClientWorkerState|
//
namespace mozilla {
namespace dom {
class IPCClientWorkerState final
{
private:
    typedef nsContentUtils::StorageAccess StorageAccess;

public:
    MOZ_IMPLICIT IPCClientWorkerState();

    MOZ_IMPLICIT IPCClientWorkerState(const StorageAccess& _storageAccess)
    {
        Init();
        Assign(_storageAccess);
    }

    MOZ_IMPLICIT IPCClientWorkerState(const IPCClientWorkerState& _o)
    {
        Init();
        Assign((_o).storageAccess());
    }

    ~IPCClientWorkerState();

    void
    operator=(const IPCClientWorkerState& _o)
    {
        Assign((_o).storageAccess());
    }

    bool
    operator==(const IPCClientWorkerState& _o) const;

    bool
    operator!=(const IPCClientWorkerState& _o) const;

    StorageAccess&
    storageAccess()
    {
        return storageAccess_;
    }
    const StorageAccess&
    storageAccess() const
    {
        return storageAccess_;
    }

private:
    void
    Init();

    void
    Assign(const StorageAccess& _storageAccess);

    StorageAccess storageAccess_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCClientWindowState;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCClientWorkerState;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCClientState|
//
namespace mozilla {
namespace dom {
class IPCClientState final
{
public:
    enum Type {
        T__None,
        TIPCClientWindowState = 1,
        TIPCClientWorkerState,
        T__Last = TIPCClientWorkerState
    };

private:
    typedef mozilla::dom::IPCClientWindowState IPCClientWindowState;
    typedef mozilla::dom::IPCClientWorkerState IPCClientWorkerState;
    typedef IPCClientWindowState IPCClientWindowState__tdef;
    typedef IPCClientWorkerState IPCClientWorkerState__tdef;

    union Value {
        mozilla::AlignedStorage2<IPCClientWindowState> VIPCClientWindowState;
        mozilla::AlignedStorage2<IPCClientWorkerState> VIPCClientWorkerState;
    };

    IPCClientWindowState*
    ptr_IPCClientWindowState()
    {
        return ((mValue).VIPCClientWindowState).addr();
    }
    const IPCClientWindowState*
    constptr_IPCClientWindowState() const
    {
        return ((mValue).VIPCClientWindowState).addr();
    }
    IPCClientWorkerState*
    ptr_IPCClientWorkerState()
    {
        return ((mValue).VIPCClientWorkerState).addr();
    }
    const IPCClientWorkerState*
    constptr_IPCClientWorkerState() const
    {
        return ((mValue).VIPCClientWorkerState).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCClientState() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCClientState(const IPCClientWindowState& aOther);

    MOZ_IMPLICIT IPCClientState(const IPCClientWorkerState& aOther);

    MOZ_IMPLICIT IPCClientState(const IPCClientState& aOther);

    ~IPCClientState();

    Type
    type() const
    {
        return mType;
    }

    IPCClientState&
    operator=(const IPCClientWindowState& aRhs);

    IPCClientState&
    operator=(const IPCClientWorkerState& aRhs);

    IPCClientState&
    operator=(const IPCClientState& aRhs);

    bool
    operator==(const IPCClientWindowState& aRhs) const;

    bool
    operator==(const IPCClientWorkerState& aRhs) const;

    bool
    operator==(const IPCClientState& aRhs) const;

    IPCClientWindowState&
    get_IPCClientWindowState()
    {
        AssertSanity(TIPCClientWindowState);
        return (*(ptr_IPCClientWindowState()));
    }
    const IPCClientWindowState&
    get_IPCClientWindowState() const
    {
        AssertSanity(TIPCClientWindowState);
        return (*(constptr_IPCClientWindowState()));
    }
    void
    get(IPCClientWindowState* aOutValue) const;
    operator IPCClientWindowState&()
    {
        return get_IPCClientWindowState();
    }
    operator const IPCClientWindowState&() const
    {
        return get_IPCClientWindowState();
    }

    IPCClientWorkerState&
    get_IPCClientWorkerState()
    {
        AssertSanity(TIPCClientWorkerState);
        return (*(ptr_IPCClientWorkerState()));
    }
    const IPCClientWorkerState&
    get_IPCClientWorkerState() const
    {
        AssertSanity(TIPCClientWorkerState);
        return (*(constptr_IPCClientWorkerState()));
    }
    void
    get(IPCClientWorkerState* aOutValue) const;
    operator IPCClientWorkerState&()
    {
        return get_IPCClientWorkerState();
    }
    operator const IPCClientWorkerState&() const
    {
        return get_IPCClientWorkerState();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCClientInfo;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCClientState;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientInfoAndState|
//
namespace mozilla {
namespace dom {
class ClientInfoAndState final
{
private:
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;
    typedef mozilla::dom::IPCClientState IPCClientState;

public:
    MOZ_IMPLICIT ClientInfoAndState();

    MOZ_IMPLICIT ClientInfoAndState(
            const IPCClientInfo& _info,
            const IPCClientState& _state)
    {
        Init();
        Assign(_info, _state);
    }

    MOZ_IMPLICIT ClientInfoAndState(const ClientInfoAndState& _o)
    {
        Init();
        Assign((_o).info(), (_o).state());
    }

    ~ClientInfoAndState();

    void
    operator=(const ClientInfoAndState& _o)
    {
        Assign((_o).info(), (_o).state());
    }

    bool
    operator==(const ClientInfoAndState& _o) const;

    bool
    operator!=(const ClientInfoAndState& _o) const;

    IPCClientInfo&
    info()
    {
        return info_;
    }
    const IPCClientInfo&
    info() const
    {
        return info_;
    }

    IPCClientState&
    state()
    {
        return state_;
    }
    const IPCClientState&
    state() const
    {
        return state_;
    }

private:
    void
    Init();

    void
    Assign(
            const IPCClientInfo& _info,
            const IPCClientState& _state);

    IPCClientInfo info_;
    IPCClientState state_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientSourceExecutionReadyArgs|
//
namespace mozilla {
namespace dom {
class ClientSourceExecutionReadyArgs final
{
private:

public:
    MOZ_IMPLICIT ClientSourceExecutionReadyArgs();

    MOZ_IMPLICIT ClientSourceExecutionReadyArgs(
            const nsCString& _url,
            const FrameType& _frameType)
    {
        Init();
        Assign(_url, _frameType);
    }

    MOZ_IMPLICIT ClientSourceExecutionReadyArgs(const ClientSourceExecutionReadyArgs& _o)
    {
        Init();
        Assign((_o).url(), (_o).frameType());
    }

    ~ClientSourceExecutionReadyArgs();

    void
    operator=(const ClientSourceExecutionReadyArgs& _o)
    {
        Assign((_o).url(), (_o).frameType());
    }

    bool
    operator==(const ClientSourceExecutionReadyArgs& _o) const;

    bool
    operator!=(const ClientSourceExecutionReadyArgs& _o) const;

    nsCString&
    url()
    {
        return url_;
    }
    const nsCString&
    url() const
    {
        return url_;
    }

    FrameType&
    frameType()
    {
        return frameType_;
    }
    const FrameType&
    frameType() const
    {
        return frameType_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _url,
            const FrameType& _frameType);

    nsCString url_;
    FrameType frameType_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCServiceWorkerDescriptor;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientControlledArgs|
//
namespace mozilla {
namespace dom {
class ClientControlledArgs final
{
private:
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;

public:
    MOZ_IMPLICIT ClientControlledArgs();

    MOZ_IMPLICIT ClientControlledArgs(const IPCServiceWorkerDescriptor& _serviceWorker)
    {
        Init();
        Assign(_serviceWorker);
    }

    MOZ_IMPLICIT ClientControlledArgs(const ClientControlledArgs& _o)
    {
        Init();
        Assign((_o).serviceWorker());
    }

    ~ClientControlledArgs();

    void
    operator=(const ClientControlledArgs& _o)
    {
        Assign((_o).serviceWorker());
    }

    bool
    operator==(const ClientControlledArgs& _o) const;

    bool
    operator!=(const ClientControlledArgs& _o) const;

    IPCServiceWorkerDescriptor&
    serviceWorker()
    {
        return serviceWorker_;
    }
    const IPCServiceWorkerDescriptor&
    serviceWorker() const
    {
        return serviceWorker_;
    }

private:
    void
    Init();

    void
    Assign(const IPCServiceWorkerDescriptor& _serviceWorker);

    IPCServiceWorkerDescriptor serviceWorker_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientFocusArgs|
//
namespace mozilla {
namespace dom {
class ClientFocusArgs final
{
private:

public:
    MOZ_IMPLICIT ClientFocusArgs()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT ClientFocusArgs(const ClientFocusArgs& _o)
    {
        Init();
        Assign();
    }

    ~ClientFocusArgs();

    void
    operator=(const ClientFocusArgs& _o)
    {
        Assign();
    }

    bool
    operator==(const ClientFocusArgs& _o) const;

    bool
    operator!=(const ClientFocusArgs& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCClientInfo;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientNavigateArgs|
//
namespace mozilla {
namespace dom {
class ClientNavigateArgs final
{
private:
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;

public:
    MOZ_IMPLICIT ClientNavigateArgs();

    MOZ_IMPLICIT ClientNavigateArgs(
            const IPCClientInfo& _target,
            const nsCString& _url,
            const nsCString& _baseURL)
    {
        Init();
        Assign(_target, _url, _baseURL);
    }

    MOZ_IMPLICIT ClientNavigateArgs(const ClientNavigateArgs& _o)
    {
        Init();
        Assign((_o).target(), (_o).url(), (_o).baseURL());
    }

    ~ClientNavigateArgs();

    void
    operator=(const ClientNavigateArgs& _o)
    {
        Assign((_o).target(), (_o).url(), (_o).baseURL());
    }

    bool
    operator==(const ClientNavigateArgs& _o) const;

    bool
    operator!=(const ClientNavigateArgs& _o) const;

    IPCClientInfo&
    target()
    {
        return target_;
    }
    const IPCClientInfo&
    target() const
    {
        return target_;
    }

    nsCString&
    url()
    {
        return url_;
    }
    const nsCString&
    url() const
    {
        return url_;
    }

    nsCString&
    baseURL()
    {
        return baseURL_;
    }
    const nsCString&
    baseURL() const
    {
        return baseURL_;
    }

private:
    void
    Init();

    void
    Assign(
            const IPCClientInfo& _target,
            const nsCString& _url,
            const nsCString& _baseURL);

    IPCClientInfo target_;
    nsCString url_;
    nsCString baseURL_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class ClonedMessageData;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCServiceWorkerDescriptor;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientPostMessageArgs|
//
namespace mozilla {
namespace dom {
class ClientPostMessageArgs final
{
private:
    typedef mozilla::dom::ClonedMessageData ClonedMessageData;
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;

public:
    MOZ_IMPLICIT ClientPostMessageArgs();

    MOZ_IMPLICIT ClientPostMessageArgs(
            const ClonedMessageData& _clonedData,
            const IPCServiceWorkerDescriptor& _serviceWorker)
    {
        Init();
        Assign(_clonedData, _serviceWorker);
    }

    MOZ_IMPLICIT ClientPostMessageArgs(const ClientPostMessageArgs& _o)
    {
        Init();
        Assign((_o).clonedData(), (_o).serviceWorker());
    }

    ~ClientPostMessageArgs();

    void
    operator=(const ClientPostMessageArgs& _o)
    {
        Assign((_o).clonedData(), (_o).serviceWorker());
    }

    bool
    operator==(const ClientPostMessageArgs& _o) const;

    bool
    operator!=(const ClientPostMessageArgs& _o) const;

    ClonedMessageData&
    clonedData()
    {
        return clonedData_;
    }
    const ClonedMessageData&
    clonedData() const
    {
        return clonedData_;
    }

    IPCServiceWorkerDescriptor&
    serviceWorker()
    {
        return serviceWorker_;
    }
    const IPCServiceWorkerDescriptor&
    serviceWorker() const
    {
        return serviceWorker_;
    }

private:
    void
    Init();

    void
    Assign(
            const ClonedMessageData& _clonedData,
            const IPCServiceWorkerDescriptor& _serviceWorker);

    ClonedMessageData clonedData_;
    IPCServiceWorkerDescriptor serviceWorker_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCServiceWorkerDescriptor;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientMatchAllArgs|
//
namespace mozilla {
namespace dom {
class ClientMatchAllArgs final
{
private:
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;

public:
    MOZ_IMPLICIT ClientMatchAllArgs();

    MOZ_IMPLICIT ClientMatchAllArgs(
            const IPCServiceWorkerDescriptor& _serviceWorker,
            const ClientType& _type,
            const bool& _includeUncontrolled)
    {
        Init();
        Assign(_serviceWorker, _type, _includeUncontrolled);
    }

    MOZ_IMPLICIT ClientMatchAllArgs(const ClientMatchAllArgs& _o)
    {
        Init();
        Assign((_o).serviceWorker(), (_o).type(), (_o).includeUncontrolled());
    }

    ~ClientMatchAllArgs();

    void
    operator=(const ClientMatchAllArgs& _o)
    {
        Assign((_o).serviceWorker(), (_o).type(), (_o).includeUncontrolled());
    }

    bool
    operator==(const ClientMatchAllArgs& _o) const;

    bool
    operator!=(const ClientMatchAllArgs& _o) const;

    IPCServiceWorkerDescriptor&
    serviceWorker()
    {
        return serviceWorker_;
    }
    const IPCServiceWorkerDescriptor&
    serviceWorker() const
    {
        return serviceWorker_;
    }

    ClientType&
    type()
    {
        return type_;
    }
    const ClientType&
    type() const
    {
        return type_;
    }

    bool&
    includeUncontrolled()
    {
        return includeUncontrolled_;
    }
    const bool&
    includeUncontrolled() const
    {
        return includeUncontrolled_;
    }

private:
    void
    Init();

    void
    Assign(
            const IPCServiceWorkerDescriptor& _serviceWorker,
            const ClientType& _type,
            const bool& _includeUncontrolled);

    IPCServiceWorkerDescriptor serviceWorker_;
    ClientType type_;
    bool includeUncontrolled_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCServiceWorkerDescriptor;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientClaimArgs|
//
namespace mozilla {
namespace dom {
class ClientClaimArgs final
{
private:
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;

public:
    MOZ_IMPLICIT ClientClaimArgs();

    MOZ_IMPLICIT ClientClaimArgs(const IPCServiceWorkerDescriptor& _serviceWorker)
    {
        Init();
        Assign(_serviceWorker);
    }

    MOZ_IMPLICIT ClientClaimArgs(const ClientClaimArgs& _o)
    {
        Init();
        Assign((_o).serviceWorker());
    }

    ~ClientClaimArgs();

    void
    operator=(const ClientClaimArgs& _o)
    {
        Assign((_o).serviceWorker());
    }

    bool
    operator==(const ClientClaimArgs& _o) const;

    bool
    operator!=(const ClientClaimArgs& _o) const;

    IPCServiceWorkerDescriptor&
    serviceWorker()
    {
        return serviceWorker_;
    }
    const IPCServiceWorkerDescriptor&
    serviceWorker() const
    {
        return serviceWorker_;
    }

private:
    void
    Init();

    void
    Assign(const IPCServiceWorkerDescriptor& _serviceWorker);

    IPCServiceWorkerDescriptor serviceWorker_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientGetInfoAndStateArgs|
//
namespace mozilla {
namespace dom {
class ClientGetInfoAndStateArgs final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT ClientGetInfoAndStateArgs();

    MOZ_IMPLICIT ClientGetInfoAndStateArgs(
            const nsID& _id,
            const PrincipalInfo& _principalInfo)
    {
        Init();
        Assign(_id, _principalInfo);
    }

    MOZ_IMPLICIT ClientGetInfoAndStateArgs(const ClientGetInfoAndStateArgs& _o)
    {
        Init();
        Assign((_o).id(), (_o).principalInfo());
    }

    ~ClientGetInfoAndStateArgs();

    void
    operator=(const ClientGetInfoAndStateArgs& _o)
    {
        Assign((_o).id(), (_o).principalInfo());
    }

    bool
    operator==(const ClientGetInfoAndStateArgs& _o) const;

    bool
    operator!=(const ClientGetInfoAndStateArgs& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _id,
            const PrincipalInfo& _principalInfo);

    nsID id_;
    PrincipalInfo principalInfo_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientOpenWindowArgs|
//
namespace mozilla {
namespace dom {
class ClientOpenWindowArgs final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT ClientOpenWindowArgs();

    MOZ_IMPLICIT ClientOpenWindowArgs(
            const PrincipalInfo& _principalInfo,
            const nsCString& _url,
            const nsCString& _baseURL)
    {
        Init();
        Assign(_principalInfo, _url, _baseURL);
    }

    MOZ_IMPLICIT ClientOpenWindowArgs(const ClientOpenWindowArgs& _o)
    {
        Init();
        Assign((_o).principalInfo(), (_o).url(), (_o).baseURL());
    }

    ~ClientOpenWindowArgs();

    void
    operator=(const ClientOpenWindowArgs& _o)
    {
        Assign((_o).principalInfo(), (_o).url(), (_o).baseURL());
    }

    bool
    operator==(const ClientOpenWindowArgs& _o) const;

    bool
    operator!=(const ClientOpenWindowArgs& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    nsCString&
    url()
    {
        return url_;
    }
    const nsCString&
    url() const
    {
        return url_;
    }

    nsCString&
    baseURL()
    {
        return baseURL_;
    }
    const nsCString&
    baseURL() const
    {
        return baseURL_;
    }

private:
    void
    Init();

    void
    Assign(
            const PrincipalInfo& _principalInfo,
            const nsCString& _url,
            const nsCString& _baseURL);

    PrincipalInfo principalInfo_;
    nsCString url_;
    nsCString baseURL_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class ClientControlledArgs;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientFocusArgs;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientNavigateArgs;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientPostMessageArgs;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientMatchAllArgs;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientClaimArgs;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientGetInfoAndStateArgs;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientOpenWindowArgs;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ClientOpConstructorArgs|
//
namespace mozilla {
namespace dom {
class ClientOpConstructorArgs final
{
public:
    enum Type {
        T__None,
        TClientControlledArgs = 1,
        TClientFocusArgs,
        TClientNavigateArgs,
        TClientPostMessageArgs,
        TClientMatchAllArgs,
        TClientClaimArgs,
        TClientGetInfoAndStateArgs,
        TClientOpenWindowArgs,
        T__Last = TClientOpenWindowArgs
    };

private:
    typedef mozilla::dom::ClientControlledArgs ClientControlledArgs;
    typedef mozilla::dom::ClientFocusArgs ClientFocusArgs;
    typedef mozilla::dom::ClientNavigateArgs ClientNavigateArgs;
    typedef mozilla::dom::ClientPostMessageArgs ClientPostMessageArgs;
    typedef mozilla::dom::ClientMatchAllArgs ClientMatchAllArgs;
    typedef mozilla::dom::ClientClaimArgs ClientClaimArgs;
    typedef mozilla::dom::ClientGetInfoAndStateArgs ClientGetInfoAndStateArgs;
    typedef mozilla::dom::ClientOpenWindowArgs ClientOpenWindowArgs;
    typedef ClientControlledArgs ClientControlledArgs__tdef;
    typedef ClientFocusArgs ClientFocusArgs__tdef;
    typedef ClientNavigateArgs ClientNavigateArgs__tdef;
    typedef ClientPostMessageArgs ClientPostMessageArgs__tdef;
    typedef ClientMatchAllArgs ClientMatchAllArgs__tdef;
    typedef ClientClaimArgs ClientClaimArgs__tdef;
    typedef ClientGetInfoAndStateArgs ClientGetInfoAndStateArgs__tdef;
    typedef ClientOpenWindowArgs ClientOpenWindowArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<ClientControlledArgs> VClientControlledArgs;
        mozilla::AlignedStorage2<ClientFocusArgs> VClientFocusArgs;
        mozilla::AlignedStorage2<ClientNavigateArgs> VClientNavigateArgs;
        mozilla::AlignedStorage2<ClientPostMessageArgs> VClientPostMessageArgs;
        mozilla::AlignedStorage2<ClientMatchAllArgs> VClientMatchAllArgs;
        mozilla::AlignedStorage2<ClientClaimArgs> VClientClaimArgs;
        mozilla::AlignedStorage2<ClientGetInfoAndStateArgs> VClientGetInfoAndStateArgs;
        mozilla::AlignedStorage2<ClientOpenWindowArgs> VClientOpenWindowArgs;
    };

    ClientControlledArgs*
    ptr_ClientControlledArgs()
    {
        return ((mValue).VClientControlledArgs).addr();
    }
    const ClientControlledArgs*
    constptr_ClientControlledArgs() const
    {
        return ((mValue).VClientControlledArgs).addr();
    }
    ClientFocusArgs*
    ptr_ClientFocusArgs()
    {
        return ((mValue).VClientFocusArgs).addr();
    }
    const ClientFocusArgs*
    constptr_ClientFocusArgs() const
    {
        return ((mValue).VClientFocusArgs).addr();
    }
    ClientNavigateArgs*
    ptr_ClientNavigateArgs()
    {
        return ((mValue).VClientNavigateArgs).addr();
    }
    const ClientNavigateArgs*
    constptr_ClientNavigateArgs() const
    {
        return ((mValue).VClientNavigateArgs).addr();
    }
    ClientPostMessageArgs*
    ptr_ClientPostMessageArgs()
    {
        return ((mValue).VClientPostMessageArgs).addr();
    }
    const ClientPostMessageArgs*
    constptr_ClientPostMessageArgs() const
    {
        return ((mValue).VClientPostMessageArgs).addr();
    }
    ClientMatchAllArgs*
    ptr_ClientMatchAllArgs()
    {
        return ((mValue).VClientMatchAllArgs).addr();
    }
    const ClientMatchAllArgs*
    constptr_ClientMatchAllArgs() const
    {
        return ((mValue).VClientMatchAllArgs).addr();
    }
    ClientClaimArgs*
    ptr_ClientClaimArgs()
    {
        return ((mValue).VClientClaimArgs).addr();
    }
    const ClientClaimArgs*
    constptr_ClientClaimArgs() const
    {
        return ((mValue).VClientClaimArgs).addr();
    }
    ClientGetInfoAndStateArgs*
    ptr_ClientGetInfoAndStateArgs()
    {
        return ((mValue).VClientGetInfoAndStateArgs).addr();
    }
    const ClientGetInfoAndStateArgs*
    constptr_ClientGetInfoAndStateArgs() const
    {
        return ((mValue).VClientGetInfoAndStateArgs).addr();
    }
    ClientOpenWindowArgs*
    ptr_ClientOpenWindowArgs()
    {
        return ((mValue).VClientOpenWindowArgs).addr();
    }
    const ClientOpenWindowArgs*
    constptr_ClientOpenWindowArgs() const
    {
        return ((mValue).VClientOpenWindowArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ClientOpConstructorArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientControlledArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientFocusArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientNavigateArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientPostMessageArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientMatchAllArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientClaimArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientGetInfoAndStateArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientOpenWindowArgs& aOther);

    MOZ_IMPLICIT ClientOpConstructorArgs(const ClientOpConstructorArgs& aOther);

    ~ClientOpConstructorArgs();

    Type
    type() const
    {
        return mType;
    }

    ClientOpConstructorArgs&
    operator=(const ClientControlledArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientFocusArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientNavigateArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientPostMessageArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientMatchAllArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientClaimArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientGetInfoAndStateArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientOpenWindowArgs& aRhs);

    ClientOpConstructorArgs&
    operator=(const ClientOpConstructorArgs& aRhs);

    bool
    operator==(const ClientControlledArgs& aRhs) const;

    bool
    operator==(const ClientFocusArgs& aRhs) const;

    bool
    operator==(const ClientNavigateArgs& aRhs) const;

    bool
    operator==(const ClientPostMessageArgs& aRhs) const;

    bool
    operator==(const ClientMatchAllArgs& aRhs) const;

    bool
    operator==(const ClientClaimArgs& aRhs) const;

    bool
    operator==(const ClientGetInfoAndStateArgs& aRhs) const;

    bool
    operator==(const ClientOpenWindowArgs& aRhs) const;

    bool
    operator==(const ClientOpConstructorArgs& aRhs) const;

    ClientControlledArgs&
    get_ClientControlledArgs()
    {
        AssertSanity(TClientControlledArgs);
        return (*(ptr_ClientControlledArgs()));
    }
    const ClientControlledArgs&
    get_ClientControlledArgs() const
    {
        AssertSanity(TClientControlledArgs);
        return (*(constptr_ClientControlledArgs()));
    }
    void
    get(ClientControlledArgs* aOutValue) const;
    operator ClientControlledArgs&()
    {
        return get_ClientControlledArgs();
    }
    operator const ClientControlledArgs&() const
    {
        return get_ClientControlledArgs();
    }

    ClientFocusArgs&
    get_ClientFocusArgs()
    {
        AssertSanity(TClientFocusArgs);
        return (*(ptr_ClientFocusArgs()));
    }
    const ClientFocusArgs&
    get_ClientFocusArgs() const
    {
        AssertSanity(TClientFocusArgs);
        return (*(constptr_ClientFocusArgs()));
    }
    void
    get(ClientFocusArgs* aOutValue) const;
    operator ClientFocusArgs&()
    {
        return get_ClientFocusArgs();
    }
    operator const ClientFocusArgs&() const
    {
        return get_ClientFocusArgs();
    }

    ClientNavigateArgs&
    get_ClientNavigateArgs()
    {
        AssertSanity(TClientNavigateArgs);
        return (*(ptr_ClientNavigateArgs()));
    }
    const ClientNavigateArgs&
    get_ClientNavigateArgs() const
    {
        AssertSanity(TClientNavigateArgs);
        return (*(constptr_ClientNavigateArgs()));
    }
    void
    get(ClientNavigateArgs* aOutValue) const;
    operator ClientNavigateArgs&()
    {
        return get_ClientNavigateArgs();
    }
    operator const ClientNavigateArgs&() const
    {
        return get_ClientNavigateArgs();
    }

    ClientPostMessageArgs&
    get_ClientPostMessageArgs()
    {
        AssertSanity(TClientPostMessageArgs);
        return (*(ptr_ClientPostMessageArgs()));
    }
    const ClientPostMessageArgs&
    get_ClientPostMessageArgs() const
    {
        AssertSanity(TClientPostMessageArgs);
        return (*(constptr_ClientPostMessageArgs()));
    }
    void
    get(ClientPostMessageArgs* aOutValue) const;
    operator ClientPostMessageArgs&()
    {
        return get_ClientPostMessageArgs();
    }
    operator const ClientPostMessageArgs&() const
    {
        return get_ClientPostMessageArgs();
    }

    ClientMatchAllArgs&
    get_ClientMatchAllArgs()
    {
        AssertSanity(TClientMatchAllArgs);
        return (*(ptr_ClientMatchAllArgs()));
    }
    const ClientMatchAllArgs&
    get_ClientMatchAllArgs() const
    {
        AssertSanity(TClientMatchAllArgs);
        return (*(constptr_ClientMatchAllArgs()));
    }
    void
    get(ClientMatchAllArgs* aOutValue) const;
    operator ClientMatchAllArgs&()
    {
        return get_ClientMatchAllArgs();
    }
    operator const ClientMatchAllArgs&() const
    {
        return get_ClientMatchAllArgs();
    }

    ClientClaimArgs&
    get_ClientClaimArgs()
    {
        AssertSanity(TClientClaimArgs);
        return (*(ptr_ClientClaimArgs()));
    }
    const ClientClaimArgs&
    get_ClientClaimArgs() const
    {
        AssertSanity(TClientClaimArgs);
        return (*(constptr_ClientClaimArgs()));
    }
    void
    get(ClientClaimArgs* aOutValue) const;
    operator ClientClaimArgs&()
    {
        return get_ClientClaimArgs();
    }
    operator const ClientClaimArgs&() const
    {
        return get_ClientClaimArgs();
    }

    ClientGetInfoAndStateArgs&
    get_ClientGetInfoAndStateArgs()
    {
        AssertSanity(TClientGetInfoAndStateArgs);
        return (*(ptr_ClientGetInfoAndStateArgs()));
    }
    const ClientGetInfoAndStateArgs&
    get_ClientGetInfoAndStateArgs() const
    {
        AssertSanity(TClientGetInfoAndStateArgs);
        return (*(constptr_ClientGetInfoAndStateArgs()));
    }
    void
    get(ClientGetInfoAndStateArgs* aOutValue) const;
    operator ClientGetInfoAndStateArgs&()
    {
        return get_ClientGetInfoAndStateArgs();
    }
    operator const ClientGetInfoAndStateArgs&() const
    {
        return get_ClientGetInfoAndStateArgs();
    }

    ClientOpenWindowArgs&
    get_ClientOpenWindowArgs()
    {
        AssertSanity(TClientOpenWindowArgs);
        return (*(ptr_ClientOpenWindowArgs()));
    }
    const ClientOpenWindowArgs&
    get_ClientOpenWindowArgs() const
    {
        AssertSanity(TClientOpenWindowArgs);
        return (*(constptr_ClientOpenWindowArgs()));
    }
    void
    get(ClientOpenWindowArgs* aOutValue) const;
    operator ClientOpenWindowArgs&()
    {
        return get_ClientOpenWindowArgs();
    }
    operator const ClientOpenWindowArgs&() const
    {
        return get_ClientOpenWindowArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class ClientInfoAndState;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientList|
//
namespace mozilla {
namespace dom {
class ClientList final
{
private:
    typedef mozilla::dom::ClientInfoAndState ClientInfoAndState;

public:
    MOZ_IMPLICIT ClientList();

    MOZ_IMPLICIT ClientList(const nsTArray<ClientInfoAndState>& _values)
    {
        Init();
        Assign(_values);
    }

    MOZ_IMPLICIT ClientList(const ClientList& _o)
    {
        Init();
        Assign((_o).values());
    }

    ~ClientList();

    void
    operator=(const ClientList& _o)
    {
        Assign((_o).values());
    }

    bool
    operator==(const ClientList& _o) const;

    bool
    operator!=(const ClientList& _o) const;

    nsTArray<ClientInfoAndState>&
    values()
    {
        return values_;
    }
    const nsTArray<ClientInfoAndState>&
    values() const
    {
        return values_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<ClientInfoAndState>& _values);

    nsTArray<ClientInfoAndState> values_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PClientSourceParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PClientSourceChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientNavigateOpConstructorArgs|
//
namespace mozilla {
namespace dom {
class ClientNavigateOpConstructorArgs final
{
private:
    typedef mozilla::dom::PClientSourceParent PClientSourceParent;
    typedef mozilla::dom::PClientSourceChild PClientSourceChild;

public:
    MOZ_IMPLICIT ClientNavigateOpConstructorArgs();

    MOZ_IMPLICIT ClientNavigateOpConstructorArgs(
            PClientSourceParent* _targetParent,
            PClientSourceChild* _targetChild,
            const nsCString& _url,
            const nsCString& _baseURL)
    {
        Init();
        Assign(_targetParent, _targetChild, _url, _baseURL);
    }

    MOZ_IMPLICIT ClientNavigateOpConstructorArgs(const ClientNavigateOpConstructorArgs& _o)
    {
        Init();
        Assign(const_cast<PClientSourceParent*>((_o).targetParent()), const_cast<PClientSourceChild*>((_o).targetChild()), (_o).url(), (_o).baseURL());
    }

    ~ClientNavigateOpConstructorArgs();

    void
    operator=(const ClientNavigateOpConstructorArgs& _o)
    {
        Assign(const_cast<PClientSourceParent*>((_o).targetParent()), const_cast<PClientSourceChild*>((_o).targetChild()), (_o).url(), (_o).baseURL());
    }

    bool
    operator==(const ClientNavigateOpConstructorArgs& _o) const;

    bool
    operator!=(const ClientNavigateOpConstructorArgs& _o) const;

    PClientSourceParent*&
    targetParent()
    {
        return targetParent_;
    }
    PClientSourceParent*
    targetParent() const
    {
        return targetParent_;
    }

    PClientSourceChild*&
    targetChild()
    {
        return targetChild_;
    }
    PClientSourceChild*
    targetChild() const
    {
        return targetChild_;
    }

    nsCString&
    url()
    {
        return url_;
    }
    const nsCString&
    url() const
    {
        return url_;
    }

    nsCString&
    baseURL()
    {
        return baseURL_;
    }
    const nsCString&
    baseURL() const
    {
        return baseURL_;
    }

private:
    void
    Init();

    void
    Assign(
            PClientSourceParent* _targetParent,
            PClientSourceChild* _targetChild,
            const nsCString& _url,
            const nsCString& _baseURL);

    PClientSourceParent* targetParent_;
    PClientSourceChild* targetChild_;
    nsCString url_;
    nsCString baseURL_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCClientState;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientInfoAndState;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ClientList;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ClientOpResult|
//
namespace mozilla {
namespace dom {
class ClientOpResult final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TIPCClientState,
        TClientInfoAndState,
        TClientList,
        T__Last = TClientList
    };

private:
    typedef mozilla::dom::IPCClientState IPCClientState;
    typedef mozilla::dom::ClientInfoAndState ClientInfoAndState;
    typedef mozilla::dom::ClientList ClientList;
    typedef nsresult nsresult__tdef;
    typedef IPCClientState IPCClientState__tdef;
    typedef ClientInfoAndState ClientInfoAndState__tdef;
    typedef ClientList ClientList__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<IPCClientState> VIPCClientState;
        mozilla::AlignedStorage2<ClientInfoAndState> VClientInfoAndState;
        mozilla::AlignedStorage2<ClientList> VClientList;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    IPCClientState*
    ptr_IPCClientState()
    {
        return ((mValue).VIPCClientState).addr();
    }
    const IPCClientState*
    constptr_IPCClientState() const
    {
        return ((mValue).VIPCClientState).addr();
    }
    ClientInfoAndState*
    ptr_ClientInfoAndState()
    {
        return ((mValue).VClientInfoAndState).addr();
    }
    const ClientInfoAndState*
    constptr_ClientInfoAndState() const
    {
        return ((mValue).VClientInfoAndState).addr();
    }
    ClientList*
    ptr_ClientList()
    {
        return ((mValue).VClientList).addr();
    }
    const ClientList*
    constptr_ClientList() const
    {
        return ((mValue).VClientList).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ClientOpResult() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ClientOpResult(const nsresult& aOther);

    MOZ_IMPLICIT ClientOpResult(const IPCClientState& aOther);

    MOZ_IMPLICIT ClientOpResult(const ClientInfoAndState& aOther);

    MOZ_IMPLICIT ClientOpResult(const ClientList& aOther);

    MOZ_IMPLICIT ClientOpResult(const ClientOpResult& aOther);

    ~ClientOpResult();

    Type
    type() const
    {
        return mType;
    }

    ClientOpResult&
    operator=(const nsresult& aRhs);

    ClientOpResult&
    operator=(const IPCClientState& aRhs);

    ClientOpResult&
    operator=(const ClientInfoAndState& aRhs);

    ClientOpResult&
    operator=(const ClientList& aRhs);

    ClientOpResult&
    operator=(const ClientOpResult& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const IPCClientState& aRhs) const;

    bool
    operator==(const ClientInfoAndState& aRhs) const;

    bool
    operator==(const ClientList& aRhs) const;

    bool
    operator==(const ClientOpResult& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    void
    get(nsresult* aOutValue) const;
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    IPCClientState&
    get_IPCClientState()
    {
        AssertSanity(TIPCClientState);
        return (*(ptr_IPCClientState()));
    }
    const IPCClientState&
    get_IPCClientState() const
    {
        AssertSanity(TIPCClientState);
        return (*(constptr_IPCClientState()));
    }
    void
    get(IPCClientState* aOutValue) const;
    operator IPCClientState&()
    {
        return get_IPCClientState();
    }
    operator const IPCClientState&() const
    {
        return get_IPCClientState();
    }

    ClientInfoAndState&
    get_ClientInfoAndState()
    {
        AssertSanity(TClientInfoAndState);
        return (*(ptr_ClientInfoAndState()));
    }
    const ClientInfoAndState&
    get_ClientInfoAndState() const
    {
        AssertSanity(TClientInfoAndState);
        return (*(constptr_ClientInfoAndState()));
    }
    void
    get(ClientInfoAndState* aOutValue) const;
    operator ClientInfoAndState&()
    {
        return get_ClientInfoAndState();
    }
    operator const ClientInfoAndState&() const
    {
        return get_ClientInfoAndState();
    }

    ClientList&
    get_ClientList()
    {
        AssertSanity(TClientList);
        return (*(ptr_ClientList()));
    }
    const ClientList&
    get_ClientList() const
    {
        AssertSanity(TClientList);
        return (*(constptr_ClientList()));
    }
    void
    get(ClientList* aOutValue) const;
    operator ClientList&()
    {
        return get_ClientList();
    }
    operator const ClientList&() const
    {
        return get_ClientList();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef ClientIPCTypes_h
